Index: issm/trunk/src/Makefile.am
===================================================================
--- issm/trunk/src/Makefile.am	(revision 25994)
+++ issm/trunk/src/Makefile.am	(revision 26744)
@@ -1,2 +1,2 @@
 EXTRA_DIST =  perl
-SUBDIRS = c m wrappers mobile
+SUBDIRS = c m wrappers
Index: issm/trunk/src/c/Makefile.am
===================================================================
--- issm/trunk/src/c/Makefile.am	(revision 25994)
+++ issm/trunk/src/c/Makefile.am	(revision 26744)
@@ -1,3 +1,3 @@
-AM_CPPFLAGS = @NEOPZINCL@ @DAKOTAINCL@ @SHAPELIBINCL@ @PETSCINCL@ @SLEPCINCL@ @AMPIINCL@ @ADJOINTMPIINCL@ @MEDIPACKINCL@ @MPIINCL@ @METISINCL@ @CHACOINCL@ @SCOTCHINCL@ @PLAPACKINCL@ @BLASLAPACKINCL@ @MKLINCL@ @MUMPSINCL@ @TRIANGLEINCL@ @SPAIINCL@ @HYPREINCL@ @PROMETHEUSINCL@ @SUPERLUINCL@ @SPOOLESINCL@ @PASTIXINCL@ @MLINCL@ @TAOINCL@ @ADIC2INCL@ @ADOLCINCL@ @CODIPACKINCL@ @GSLINCL@ @BOOSTINCL@ @ANDROID_NDKINCL@ @METEOIOINCL@ @SNOWPACKINCL@ @PROJINCL@ @ESMFINCL@
+AM_CPPFLAGS = @NEOPZINCL@ @DAKOTAINCL@ @SHAPELIBINCL@ @TRIANGLEINCL@ @PETSCINCL@ @SLEPCINCL@ @AMPIINCL@ @ADJOINTMPIINCL@ @MEDIPACKINCL@ @MPIINCL@ @PARMETISINCL@ @METISINCL@ @CHACOINCL@ @SCOTCHINCL@ @PLAPACKINCL@ @MKLINCL@ @MUMPSINCL@ @SPAIINCL@ @HYPREINCL@ @PROMETHEUSINCL@ @SUPERLUINCL@ @SPOOLESINCL@ @PASTIXINCL@ @MLINCL@ @TAOINCL@ @ADIC2INCL@ @ADOLCINCL@ @CODIPACKINCL@ @GSLINCL@ @BOOSTINCL@ @ANDROID_NDKINCL@ @METEOIOINCL@ @SNOWPACKINCL@ @PROJINCL@ @ESMFINCL@ @PROJINCL@
 AM_FCFLAGS = @SEMICINCL@
 
@@ -6,7 +6,10 @@
 EXEEXT=$(ISSMEXT)
 
-#Library declaration {{{
+# Library declaration {{{
 if !WINDOWS
-lib_LTLIBRARIES = libISSMCore.la libISSMOverload.la
+lib_LTLIBRARIES = libISSMCore.la
+if !MSYS2
+lib_LTLIBRARIES += libISSMOverload.la
+endif
 if WRAPPERS
 lib_LTLIBRARIES += libISSMModules.la
@@ -20,8 +23,8 @@
 #}}}
 
-#Core sources
+# Core sources
 issm_sources =
 
-#BAMG sources  {{{
+# BAMG sources {{{
 if BAMG
 issm_sources += \
@@ -54,5 +57,5 @@
 	./modules/BamgTriangulatex/BamgTriangulatex.cpp
 
-#do not include AmrBamg with AD
+# Do not include AmrBamg with AD
 if ADOLC
 issm_sources += \
@@ -68,5 +71,5 @@
 endif
 #}}}
-#Core sources{{{
+# Core sources {{{
 issm_sources += \
 	./datastructures/DataSet.cpp \
@@ -88,4 +91,5 @@
 	./classes/Cfdragcoeffabsgrad.cpp \
 	./classes/Cfsurfacelogvel.cpp \
+	./classes/Cflevelsetmisfit.cpp \
 	./classes/Regionaloutput.cpp \
 	./classes/Nodalvalue.cpp \
@@ -94,4 +98,5 @@
 	./classes/Hook.cpp \
 	./classes/Radar.cpp \
+	./classes/BarystaticContributions.cpp \
 	./classes/ExternalResults/Results.cpp \
 	./classes/Elements/Element.cpp \
@@ -182,4 +187,6 @@
 	./shared/Elements/DrainageFunctionWaterfraction.cpp \
 	./shared/Elements/EstarComponents.cpp \
+	./shared/Random/random.cpp \
+	./shared/Random/randomgenerator.cpp \
 	./shared/String/DescriptorIndex.cpp \
 	./toolkits/issm/IssmToolkitUtils.cpp \
@@ -191,4 +198,5 @@
 	./toolkits/mpi/commops/GetOwnershipBoundariesFromRange.cpp \
 	./toolkits/ToolkitOptions.cpp \
+	./modules/MmeToInputFromIdx/MmeToInputFromIdx.cpp\
 	./modules/ModelProcessorx/ModelProcessorx.cpp \
 	./modules/ModelProcessorx/ElementsAndVerticesPartitioning.cpp \
@@ -208,4 +216,5 @@
 	./modules/NodalValuex/NodalValuex.cpp \
 	./modules/VertexCoordinatesx/VertexCoordinatesx.cpp \
+	./modules/ElementCoordinatesx/ElementCoordinatesx.cpp \
 	./modules/OutputResultsx/OutputResultsx.cpp \
 	./modules/InputDepthAverageAtBasex/InputDepthAverageAtBasex.cpp \
@@ -239,8 +248,10 @@
 	./modules/ResetFSBasalBoundaryConditionx/ResetFSBasalBoundaryConditionx.cpp \
 	./modules/Solverx/Solverx.cpp \
+	./modules/StochasticForcingx/StochasticForcingx.cpp \
 	./modules/Mergesolutionfromftogx/Mergesolutionfromftogx.cpp \
 	./cores/ProcessArguments.cpp \
 	./cores/ResetBoundaryConditions.cpp \
 	./cores/WrapperCorePointerFromSolutionEnum.cpp \
+	./cores/WrapperPreCorePointerFromSolutionEnum.cpp \
 	./cores/CorePointerFromSolutionEnum.cpp \
 	./cores/ad_core.cpp \
@@ -256,4 +267,5 @@
 	./solutionsequences/solutionsequence_fct.cpp \
 	./solutionsequences/solutionsequence_schurcg.cpp \
+	./solutionsequences/solutionsequence_sampling.cpp \
 	./solutionsequences/convergence.cpp \
 	./classes/Options/Options.cpp \
@@ -264,4 +276,5 @@
 	./cores/steadystate_core.cpp \
 	./cores/masstransport_core.cpp \
+	./cores/oceantransport_core.cpp \
 	./cores/depthaverage_core.cpp \
 	./cores/extrudefrombase_core.cpp \
@@ -334,5 +347,5 @@
 	./classes/Inputs/ArrayInput.cpp
 #}}}
-#ADJOINTMPI/MeDiPack sources {{{
+# ADJOINTMPI/MeDiPack sources {{{
 if ADJOINTMPI
 issm_sources += ./toolkits/codipack/ampi_interface.cpp
@@ -341,6 +354,6 @@
 issm_sources += ./toolkits/codipack/ampi_interface.cpp
 endif
-# }}}
-#DAKOTA sources  {{{
+#}}}
+# DAKOTA sources {{{
 if DAKOTA
 issm_sources += \
@@ -359,5 +372,5 @@
 endif
 #}}}
-#Petsc sources  {{{
+# PETSc sources {{{
 if PETSC
 issm_sources += \
@@ -365,5 +378,5 @@
 	./toolkits/petsc/patches \
 	./toolkits/petsc/patches/VecToMPISerial.cpp \
-	./toolkits/petsc/patches/MatToSerial.cpp \
+	./toolkits/petsc/patches/MatToMPISerial.cpp \
 	./toolkits/petsc/patches/NewVec.cpp \
 	./toolkits/petsc/patches/PetscOptionsDetermineSolverType.cpp \
@@ -381,20 +394,20 @@
 endif
 #}}}
-#Mumps sources  {{{
+# MUMPS sources {{{
 if MUMPS
 issm_sources += ./toolkits/mumps/MumpsSolve.cpp
 endif
 #}}}
-#Gsl sources  {{{
+#GSL sources {{{
 if GSL
 issm_sources += ./toolkits/gsl/DenseGslSolve.cpp
 endif
 #}}}
-#proj sources  {{{
+# PROJ sources {{{
 if PROJ
 issm_sources += ./modules/CoordinateSystemTransformx/CoordinateSystemTransformx.cpp
 endif
 #}}}
-#Analyses{{{
+# Analyses {{{
 if ADJOINTBALANCETHICKNESS
 issm_sources += ./analyses/AdjointBalancethicknessAnalysis.cpp
@@ -446,4 +459,8 @@
 issm_sources += ./analyses/HydrologyShreveAnalysis.cpp
 endif
+if HYDROLOGYTWS
+issm_sources += ./analyses/HydrologyTwsAnalysis.cpp
+endif
+
 if HYDROLOGYSHAKTI
 issm_sources += ./analyses/HydrologyShaktiAnalysis.cpp
@@ -469,4 +486,7 @@
 if MASSTRANSPORT
 issm_sources += ./analyses/MasstransportAnalysis.cpp
+endif
+if OCEANTRANSPORT
+issm_sources += ./analyses/OceantransportAnalysis.cpp
 endif
 if SMB
@@ -504,10 +524,49 @@
 endif
 #}}}
-#Gia sources (only if have fortran){{{
-if GIA
+# Love sources (only if have Fortran) {{{
+if LOVE
 if FORTRAN
 issm_sources += \
-	./cores/gia_core.cpp \
-	./analyses/GiaAnalysis.cpp \
+	./cores/love_core.cpp \
+	./analyses/LoveAnalysis.cpp \
+	./modules/FourierLoveCorex/FourierLoveCorex.cpp \
+	./modules/FourierLoveCorex/lnb_param.f90 \
+	./modules/FourierLoveCorex/model.f90 \
+	./modules/FourierLoveCorex/util.f90 \
+	./modules/FourierLoveCorex/lovenb_sub.f90 \
+	./modules/FourierLoveCorex/love_numbers.f90
+endif
+endif
+#}}}
+# Esa sources {{{
+if ESA
+issm_sources += \
+	./cores/esa_core.cpp \
+	./analyses/EsaAnalysis.cpp
+endif
+#}}}
+# Ocean sources {{{
+if OCEAN
+issm_sources += ./modules/OceanExchangeDatax/OceanExchangeDatax.cpp
+endif
+#}}}
+# Sampling sources {{{
+if SAMPLING
+issm_sources += \
+	./cores/sampling_core.cpp \
+	./analyses/SamplingAnalysis.cpp
+endif
+#}}}
+# SLC sources {{{
+if SEALEVELCHANGE
+issm_sources += \
+	./cores/sealevelchange_core.cpp \
+	./analyses/SealevelchangeAnalysis.cpp\
+	./classes/GrdLoads.cpp\
+	./classes/SealevelGeometry.cpp
+
+# GIA Ivins physics (only if have Fortran)
+if FORTRAN
+issm_sources += \
 	./modules/GiaDeflectionCorex/GiaDeflectionCorex.cpp \
 	./modules/GiaDeflectionCorex/distme.f \
@@ -519,51 +578,18 @@
 	./modules/GiaDeflectionCorex/what0.f
 endif
-endif
-#}}}
-#Love sources (only if have fortran){{{
-if LOVE
-if FORTRAN
-issm_sources += \
-	./cores/love_core.cpp \
-	./analyses/LoveAnalysis.cpp \
-	./modules/FourierLoveCorex/FourierLoveCorex.cpp \
-	./modules/FourierLoveCorex/lnb_param.f90 \
-	./modules/FourierLoveCorex/model.f90 \
-	./modules/FourierLoveCorex/util.f90 \
-	./modules/FourierLoveCorex/lovenb_sub.f90 \
-	./modules/FourierLoveCorex/love_numbers.f90
-endif
-endif
-#}}}
-#Esa sources  {{{
-if ESA
-issm_sources += \
-	./cores/esa_core.cpp \
-	./analyses/EsaAnalysis.cpp
-endif
-#}}}
-#Oceansources  {{{
-if OCEAN
-issm_sources += ./modules/OceanExchangeDatax/OceanExchangeDatax.cpp
-endif
-#}}}
-#Slr sources  {{{
-if SEALEVELRISE
-issm_sources += \
-	./cores/sealevelchange_core.cpp \
-	./analyses/SealevelriseAnalysis.cpp
-endif
-#}}}
-#Metis sources  {{{
+
+endif
+#}}}
+# METIS sources {{{
 if METIS
 issm_sources += ./toolkits/metis/patches/METIS_PartMeshNodalPatch.cpp
 endif
 #}}}
-#Esmf sources  {{{
+# Esmf sources {{{
 if ESMF
 issm_sources += ./main/esmfbinders.cpp
 endif
 #}}}
-#SEMIC sources  {{{
+# SEMIC sources {{{
 if SEMIC
 if FORTRAN
@@ -572,6 +598,6 @@
 endif
 #}}}
-#Wrapper sources
-#Kml sources  {{{
+# Wrapper sources
+# Kml sources {{{
 kml_sources = \
 	./modules/Exp2Kmlx/Exp2Kmlx.cpp \
@@ -609,8 +635,8 @@
 	./kml/KMLFileReadUtils.cpp
 #}}}
-#NEOPZ sources  {{{
+# NEOPZ sources {{{
 neopz_sources = ./classes/AmrNeopz.cpp
 #}}}
-#Modules sources{{{
+# Modules sources {{{
 modules_sources = \
 	./shared/Threads/LaunchThread.cpp \
@@ -641,5 +667,5 @@
 	./modules/NodeConnectivityx/NodeConnectivityx.cpp \
 	./modules/ElementConnectivityx/ElementConnectivityx.cpp \
-	./modules/PropagateFlagsFromConnectivityx/PropagateFlagsFromConnectivityx.cpp 
+	./modules/PropagateFlagsFromConnectivityx/PropagateFlagsFromConnectivityx.cpp
 
 if CHACO
@@ -655,6 +681,6 @@
 #}}}
 
-#kriging (WRAPPER and executable)
-#Kriging sources  {{{
+# Kriging (wrapper and executable)
+# Kriging sources {{{
 if KRIGING
 issm_sources += \
@@ -674,14 +700,19 @@
 endif
 #}}}
-#Library flags and sources {{{
-ALLCXXFLAGS= $(CXXFLAGS) $(CXXOPTFLAGS)
+# Library flags and sources {{{
+ALL_CXXFLAGS = $(CXXFLAGS) $(CXXOPTFLAGS)
+
+if MSYS2
+ALL_CXXFLAGS += -D_DO_NOT_LOAD_GLOBALS_ # Cannot have undefined symbols under MSYS2
+ALL_CXXFLAGS += -D_USE_MATH_DEFINES # Need to open fence to math.h definitions when --std=c++ is used (which is the default)
+endif
 
 libISSMCore_la_SOURCES  = $(issm_sources)
-libISSMCore_la_CXXFLAGS = $(ALLCXXFLAGS) $(DAKOTAFLAGS)
+libISSMCore_la_CXXFLAGS = $(ALL_CXXFLAGS) $(DAKOTAFLAGS)
 libISSMCore_la_FFLAGS = $(AM_FFLAGS)
 
 if !WINDOWS
 if !STANDALONE_LIBRARIES
-libISSMCore_la_LIBADD = $(PETSCLIB) $(HDF5LIB) $(TAOLIB) $(M1QN3LIB) $(SEMICLIB) $(PLAPACKLIB) $(MUMPSLIB) $(SUPERLULIB) $(SPOOLESLIB) $(SCALAPACKLIB) $(BLACSLIB) $(HYPRELIB) $(SPAILIB) $(PROMETHEUSLIB) $(PASTIXLIB) $(MLLIB) $(DAKOTALIB) $(METISLIB) $(CHACOLIB) $(SCOTCHLIB) $(BLASLAPACKLIB) $(MKLLIB) $(MPILIB) $(MATHLIB) $(GRAPHICSLIB) $(MULTITHREADINGLIB) $(OSLIBS) $(GSLLIB) $(ADOLCLIB) $(AMPILIB) $(ADJOINTMPILIB) $(METEOIOLIB) $(SNOWPACKLIB)
+libISSMCore_la_LIBADD = $(CHACOLIB) $(DAKOTALIB) $(PETSCLIB) $(MUMPSLIB) $(SCALAPACKLIB) $(BLASLAPACKLIB) $(PARMETISLIB) $(METISLIB) $(HDF5LIB) $(TAOLIB) $(M1QN3LIB) $(SEMICLIB) $(PLAPACKLIB) $(SUPERLULIB) $(SPOOLESLIB) $(BLACSLIB) $(HYPRELIB) $(SPAILIB) $(PROMETHEUSLIB) $(PASTIXLIB) $(MLLIB) $(SCOTCHLIB) $(MKLLIB) $(MPILIB) $(MATHLIB) $(GRAPHICSLIB) $(MULTITHREADINGLIB) $(GSLLIB) $(ADOLCLIB) $(AMPILIB) $(ADJOINTMPILIB) $(METEOIOLIB) $(SNOWPACKLIB) $(PROJLIB) $(OSLIBS)
 if FORTRAN
 libISSMCore_la_LIBADD += $(FLIBS) $(FORTRANLIB)
@@ -704,10 +735,10 @@
 endif
 
-libISSMModules_la_CXXFLAGS = $(ALLCXXFLAGS)
+libISSMModules_la_CXXFLAGS = $(ALL_CXXFLAGS)
 if !WINDOWS
 if STANDALONE_LIBRARIES
 libISSMModules_la_LIBADD = ./libISSMCore.la
 else
-libISSMModules_la_LIBADD = ./libISSMCore.la $(TRIANGLELIB) $(CHACOLIB)
+libISSMModules_la_LIBADD = ./libISSMCore.la $(TRIANGLELIB) $(CHACOLIB) $(BLASLAPACKLIB) $(OSLIBS)
 endif
 endif
@@ -736,27 +767,44 @@
 endif
 
+if VERSION
+libISSMCore_la_LDFLAGS =
+if WRAPPERS
+libISSMModules_la_LDFLAGS =
+endif
+else
+libISSMCore_la_LDFLAGS = -avoid-version
+if WRAPPERS
+libISSMModules_la_LDFLAGS = -avoid-version
+endif
+endif
+
 if STANDALONE_LIBRARIES
-libISSMCore_la_LDFLAGS = -static
-libISSMOverload_la_LDFLAGS = -static
+libISSMCore_la_LDFLAGS += -static
 if WRAPPERS
-libISSMModules_la_LDFLAGS = -static
-else
-libISSMModules_la_LDFLAGS =
-endif
-else
-libISSMCore_la_LDFLAGS =
+libISSMModules_la_LDFLAGS += -static
+endif
+endif
+#}}}
+
+if !MSYS2
+# Overload library, to overload any non-standard symbols {{{
+libISSMOverload_la_SOURCES = ./shared/String/ApiPrintf.cpp
+libISSMOverload_la_CFLAGS  = -D_C_ -fPIC $(COPTFLAGS) $(CFLAGS)
+
+if VERSION
 libISSMOverload_la_LDFLAGS =
-endif
-
-#}}}
-#Overload library, to overload any non-standard symbols. {{{
-libISSMOverload_la_SOURCES = ./shared/String/ApiPrintf.cpp
-
-libISSMOverload_la_CFLAGS  = -D_C_ -fPIC $(COPTFLAGS) $(CFLAGS)
-#}}}
-#Executable {{{
+else
+libISSMOverload_la_LDFLAGS = -avoid-version
+endif
+
+if STANDALONE_LIBRARIES
+libISSMOverload_la_LDFLAGS += -static
+endif
+endif
+#}}}
+# Executable {{{
 if ANDROID
 if ANDROIDEXE
-bin_PROGRAMS = issm issm_slr
+bin_PROGRAMS = issm issm_slc
 else
 bin_PROGRAMS =
@@ -766,16 +814,21 @@
 bin_PROGRAMS =
 else
-bin_PROGRAMS = issm issm_slr
-endif
-endif
-
-#Standard libraries
-LDADD = ./libISSMCore.la ./libISSMOverload.la
+bin_PROGRAMS = issm issm_slc
+endif
+endif
+
+# Standard libraries
+LDADD = ./libISSMCore.la
+
+if !MSYS2
+LDADD += ./libISSMOverload.la
+endif
+
 if WRAPPERS
 LDADD += ./libISSMModules.la $(TRIANGLELIB)
 endif
 
-#External packages
-LDADD += $(NEOPZLIB) $(TAOLIB) $(M1QN3LIB) $(SEMICLIB) $(PLAPACKLIB) $(MUMPSLIB) $(SUPERLULIB) $(SPOOLESLIB) $(SCALAPACKLIB) $(BLACSLIB) $(PETSCLIB) $(HDF5LIB) $(HYPRELIB) $(SPAILIB) $(PROMETHEUSLIB) $(PASTIXLIB) $(MLLIB) $(DAKOTALIB) $(METISLIB) $(CHACOLIB) $(SCOTCHLIB) $(BLASLAPACKLIB) $(MKLLIB) $(MPILIB) $(MATHLIB) $(GRAPHICSLIB) $(MULTITHREADINGLIB) $(OSLIBS) $(GSLLIB) $(AMPILIB) $(ADJOINTMPILIB) $(ADOLCLIB) $(MPILIB) $(METEOIOLIB) $(SNOWPACKLIB) $(PROJLIB) $(ESMFLIB)
+# External packages
+LDADD += $(CHACOLIB) $(DAKOTALIB) $(PETSCLIB) $(MUMPSLIB) $(SCALAPACKLIB) $(BLASLAPACKLIB) $(PARMETISLIB) $(METISLIB) $(NEOPZLIB) $(TAOLIB) $(M1QN3LIB) $(SEMICLIB) $(PLAPACKLIB) $(SUPERLULIB) $(SPOOLESLIB) $(BLACSLIB) $(HDF5LIB) $(HYPRELIB) $(SPAILIB) $(PROMETHEUSLIB) $(PASTIXLIB) $(MLLIB) $(SCOTCHLIB) $(MKLLIB) $(MPILIB) $(MATHLIB) $(GRAPHICSLIB) $(MULTITHREADINGLIB) $(GSLLIB) $(AMPILIB) $(ADJOINTMPILIB) $(ADOLCLIB) $(MPILIB) $(METEOIOLIB) $(SNOWPACKLIB) $(PROJLIB) $(ESMFLIB) $(OSLIBS)
 
 if FORTRAN
@@ -783,9 +836,9 @@
 endif
 
-issm_SOURCES = main/issm.cpp 
+issm_SOURCES = main/issm.cpp
 issm_CXXFLAGS= $(CXXFLAGS) $(CXXOPTFLAGS)
 
-issm_slr_SOURCES = main/issm_slr.cpp
-issm_slr_CXXFLAGS= $(CXXFLAGS) $(CXXOPTFLAGS)
+issm_slc_SOURCES = main/issm_slc.cpp
+issm_slc_CXXFLAGS= $(CXXFLAGS) $(CXXOPTFLAGS)
 
 if OCEAN
Index: issm/trunk/src/c/analyses/AdjointBalancethickness2Analysis.cpp
===================================================================
--- issm/trunk/src/c/analyses/AdjointBalancethickness2Analysis.cpp	(revision 25994)
+++ issm/trunk/src/c/analyses/AdjointBalancethickness2Analysis.cpp	(revision 26744)
@@ -28,4 +28,7 @@
 /*Finite Element Analysis*/
 void           AdjointBalancethickness2Analysis::Core(FemModel* femmodel){/*{{{*/
+	_error_("not implemented");
+}/*}}}*/
+void           AdjointBalancethickness2Analysis::PreCore(FemModel* femmodel){/*{{{*/
 	_error_("not implemented");
 }/*}}}*/
Index: issm/trunk/src/c/analyses/AdjointBalancethickness2Analysis.h
===================================================================
--- issm/trunk/src/c/analyses/AdjointBalancethickness2Analysis.h	(revision 25994)
+++ issm/trunk/src/c/analyses/AdjointBalancethickness2Analysis.h	(revision 26744)
@@ -22,4 +22,5 @@
 		/*Finite element Analysis*/
 		void           Core(FemModel* femmodel);
+		void           PreCore(FemModel* femmodel);
 		ElementVector* CreateDVector(Element* element);
 		ElementMatrix* CreateJacobianMatrix(Element* element);
Index: issm/trunk/src/c/analyses/AdjointBalancethicknessAnalysis.cpp
===================================================================
--- issm/trunk/src/c/analyses/AdjointBalancethicknessAnalysis.cpp	(revision 25994)
+++ issm/trunk/src/c/analyses/AdjointBalancethicknessAnalysis.cpp	(revision 26744)
@@ -28,4 +28,7 @@
 /*Finite Element Analysis*/
 void           AdjointBalancethicknessAnalysis::Core(FemModel* femmodel){/*{{{*/
+	_error_("not implemented");
+}/*}}}*/
+void           AdjointBalancethicknessAnalysis::PreCore(FemModel* femmodel){/*{{{*/
 	_error_("not implemented");
 }/*}}}*/
@@ -148,5 +151,5 @@
 	xDelete<IssmDouble>(basis);
 	xDelete<IssmDouble>(dbasis);
-	if(domaintype!=Domain2DhorizontalEnum){basalelement->DeleteMaterials(); delete basalelement;};
+	if(basalelement->IsSpawnedElement()){basalelement->DeleteMaterials(); delete basalelement;};
 	delete gauss;
 	return pe;
@@ -224,9 +227,9 @@
 	/*Transpose and return Ke*/
 	Ke->Transpose();
-	_assert_(Ke->nrows == numvertices && Ke->ncols == numvertices);
+	_assert_(Ke->nrows == numvertices);
 
 	for(int i=0;i<numvertices;i++){
 		for(int j=0;j<numvertices;j++){
-			ge[i] += Ke->values[i*Ke->ncols + j] * lambda[j];
+			ge[i] += Ke->values[i*Ke->nrows + j] * lambda[j];
 		}
 		//ge[i]=-lambda[i];
Index: issm/trunk/src/c/analyses/AdjointBalancethicknessAnalysis.h
===================================================================
--- issm/trunk/src/c/analyses/AdjointBalancethicknessAnalysis.h	(revision 25994)
+++ issm/trunk/src/c/analyses/AdjointBalancethicknessAnalysis.h	(revision 26744)
@@ -22,4 +22,5 @@
 		/*Finite element Analysis*/
 		void           Core(FemModel* femmodel);
+		void           PreCore(FemModel* femmodel);
 		ElementVector* CreateDVector(Element* element);
 		ElementMatrix* CreateJacobianMatrix(Element* element);
